{% extends "template/app.twig" %}

{% block meta %}
    {% set meta = {'keywords': 'Oportunidades'} %}
    {{ parent() }}
{% endblock %}

{% block link %}
    {{ parent() }}
{% endblock %}

{% block header %}
    {{ parent() }}
{% endblock %}

{% block aside %}
    {{ parent() }}
{% endblock %}

{% block content %}
    {{ parent() }}
    {% include "template/partial/section/opportunity_list.twig" %}
    {% include "template/partial/modal/client_detail.twig" %}
{% endblock %}

{% block footer %}
    {{ parent() }}
{% endblock %}

{% block script %}
    {{ parent() }}

    {% if new=="new" %}
        <script>
            $(document).ready(function () {
                $('#modalDefault').modal('show');
            });
        </script>
    {% endif %}


    <script>
        $(document).ready(function () {

            var dataSource = new Bloodhound({
                datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name'),
                queryTokenizer: Bloodhound.tokenizers.whitespace,
                prefetch: {
                    url: "{{base_url()}}/oportunidad/jsonUsuarios",
                    cache: false,
                    ttl: 1
                }
            });

            $('.typeusersoppotunity').typeahead({
                hint: true,
                cache: false,
                ttl: 60,
                highlight: true,
                minLength: 1
            },
                    {
                        displayKey: 'name',
                        valueKey: 'id',
                        name: 'users',
                        source: dataSource.ttAdapter()
                    });

            //////////////////////////////////////////////
            $(".i-toggle, .te-toggle, .i-te-content").hide();

            var dataSource2 = new Bloodhound({
                datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name'),
                queryTokenizer: Bloodhound.tokenizers.whitespace,
                prefetch: {
                    url: "{{base_url()}}/oportunidad/jsonClientes",
                    cache: false,
                    ttl: 1
                }
            });

            $('.typeclients').typeahead({
                hint: true,
                cache: false,
                ttl: 60,
                highlight: true,
                minLength: 1
            },
            {
                displayKey: 'name',
                name: 'clients',
                valueKey: 'id',
                source: dataSource2.ttAdapter()
            }).bind("typeahead:selected", function (obj, datum, name) {
                if (this.id == "client_id") {
                  $("#client_id_value").val(datum.id);
                  $("#terceraEmpresa").hide();
                  $('.i-te-content').show();

      					if(datum.type=="Tercera Empresa"){
      						$("#terceraEmpresa").show();
      					}

                if(datum.type=="Integrador"){
      						$(".te-toggle").show('slow');
                  $(".i-toggle").hide('slow');

                  $("#cisn").prop('checked', false);
                  changeCisn($("#cisn"));
      					} else {
                  $(".te-toggle").hide('slow');
                  $(".i-toggle").show('slow');

                  $("#tesn").prop('checked', false);
                  changeTesn($("#tesn"));
                }

                $("#companyId").attr("href", "../../cliente/editar/" + datum.id);

                $.ajax({
                    type: "GET",
                    url: "{{base_url()}}/oportunidad/jsonContactos/" + datum.id,
                    dataType: "JSON",
                    success: function (data) {
                        console.log(data);
                        $('#contact_id_value').html("");
		                   var elementos = 0;

                      for (var i in data) {
        								if(data[i].name!=""){
        									$('#contact_id_value').append("<option value='" + data[i].id + "'>" + data[i].name + "</option>");
        									elementos++;
        								}
                      }

        							if(elementos==0){
        								$('#contact_id_value').append("<option value='0'>Sin contactos...</option>");

        								$('#link-cliente').attr('href', '../../cliente/editar/'+datum.id)
        								$('#sin-contactos').show();
        							}

                      $('#contact_id_value').trigger("chosen:updated");
                      }
                });

                    $.ajax({
                        type: "GET",
                        url: "{{base_url()}}/oportunidad/jsonCliente/"+datum.id+"/type",
                        dataType: "JSON",
                        success: function (data) {
                            console.log(data);
                            if(data.client_type === "Integrador") {
                                $('#tesn').removeAttr('disabled')
                            } else {
                                $('#tesn').attr('disabled', 'disabled');
                            }
                        }
                    });

                }

                if (this.id == "opportunity_integrator_user_id") {
                    $("#opportunity_integrator_user_id_value").val(datum.id);
                }

                if (this.id == "opportunity_subclient_id") {
                    $("#opportunity_subclient_id_value").val(datum.id);
                }
            });
            /////////////////////////////

            var dataSource10 = new Bloodhound({
                datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name'),
                queryTokenizer: Bloodhound.tokenizers.whitespace,
                prefetch: {
                  url: "{{path_for('opportunity-client-email')}}",
                  cache: false,
                  ttl: 1
                }
            });

            $('.typeEmail').typeahead({
              hint: true,
              cache: false,
              ttl: 60,
              highlight: true,
              minLength: 1
            },
            {
              displayKey: 'name',
              name: 'name',
              valueKey: 'name',
              source: dataSource10.ttAdapter()
            });
            /////////////////////////////

            /////////////////////////////

            var dataSource3 = new Bloodhound({
                datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name'),
                queryTokenizer: Bloodhound.tokenizers.whitespace,
                prefetch: {
                    url: "{{base_url()}}/oportunidad/jsonClientes/Integrador",
                    cache: false,
                    ttl: 1
                }
            });

            $('.typeIntegrator').typeahead({
                hint: true,
                cache: false,
                ttl: 60,
                highlight: true,
                minLength: 1
            },
                    {
                        displayKey: 'name',
                        name: 'clients',
                        valueKey: 'id',
                        source: dataSource3.ttAdapter()
                    }).bind("typeahead:selected", function (obj, datum, name) {
                if (this.id == "opportunity_integrator_user_id") {
                    $("#opportunity_integrator_user_id_value").val(datum.id);
                }
            });

            /////////////////////////////
            /////////////////////////////

            var dataSource4 = new Bloodhound({
                datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name'),
                queryTokenizer: Bloodhound.tokenizers.whitespace,
                prefetch: {
                    url: "{{base_url()}}/oportunidad/jsonClientes/Tercera Empresa",
                    cache: false
                }
            });

            $('.typeSubClient').typeahead({
                hint: true,
                cache: false,
                ttl: 60,
                highlight: true,
                minLength: 1
            },
                    {
                        displayKey: 'name',
                        name: 'clients',
                        valueKey: 'id',
                        source: dataSource4.ttAdapter()
                    }).bind("typeahead:selected", function (obj, datum, name) {
                if (this.id == "opportunity_subclient_id") {
                    $("#opportunity_subclient_id_value").val(datum.id);
                }
            });

            //////////////////////////////////////////////

            /*var dataSource3 = new Bloodhound({
             datumTokenizer: Bloodhound.tokenizers.obj.whitespace('name'),
             queryTokenizer: Bloodhound.tokenizers.whitespace,
             prefetch: {
             url: "{{base_url()}}/oportunidad/jsonContactos"
             }
             });

             $('.typecontacts').typeahead({
             hint: true,
             highlight: true,
             minLength: 1
             },
             {
             displayKey: 'name',
             valueKey: 'id',
             name:'contacts',
             source: dataSource3.ttAdapter()
             }).bind("typeahead:selected", function(obj, datum, name) {
             if(this.id=="contact_id"){
             $("#contact_id_value").val(datum.id);
             }
             });*/

            ///////////////////////////
            ///////////////////////////
            ///////////////////////////

            $('#crearOportunidad').click(function () {

                if ($("#client_id").val() == "") {
                    notify('Campo Cliente es requerido!', 'warning');
                    $(".fo1Has").addClass("has-warning");
                    return false;
                } else {
                    $(".fo1Has").removeClass("has-warning");
                }

                if ($("#opportunity_reason").val() == "") {
                    notify('Campo Origen Oportunidad es requerido!', 'warning');
                    $(".fo2Has").addClass("has-warning");
                    return false;
                } else {
                    $(".fo2Has").removeClass("has-warning");
                }

                if ($("#opportunity_stage").val() == "") {
                    notify('Campo Etapa Oportunidad es requerido!', 'warning');
                    $(".fo3Has").addClass("has-warning");
                    return false;
                } else {
                    $(".fo3Has").removeClass("has-warning");
                }

                if ($("#opportunity_type").val() == "") {
                    notify('Campo Tipo Oportunidad es requerido!', 'warning');
                    $(".fo4Has").addClass("has-warning");
                    return false;
                } else {
                    $(".fo4Has").removeClass("has-warning");
                }

                if ($("#brand_id").val() == "") {
                    notify('Campo Marca es requerido!', 'warning');
                    $(".fo5Has").addClass("has-warning");
                    return false;
                } else {
                    $(".fo5Has").removeClass("has-warning");
                }

                if ($("#contact_id_value").val() == "" || $("#contact_id_value").val() == "0") {
                    notify('Debes seleccionar o adicionar un contacto del cliente para crear la oportunidad!', 'warning');
                    $(".fo6Has").addClass("has-warning");
                    return false;
                } else {
                    $(".fo6Has").removeClass("has-warning");
                }

                ///////

                var json = objectifyForm($('#form-no').serializeArray());

                $.ajax({
                    type: "POST",
                    data: json,
                    url: "../../oportunidad/crearOportunidad",
                    success: function (data) {
                        console.log(data);

                        swal("Oportunidad Creada", "Preparando plantilla de oportunidad...", "success");

                        setTimeout(function () {
                            window.location.href = "../../oportunidad/editar/" + data;
                        }, 1500);
                    },
                    error: function (data) {
                        console.log(data);

                        notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                    }
                });
            });

            //////////////////////////////////////////////

            //Selection
            var gridClient = $("#data-table-selection-oportunities").bootgrid({
                css: {
                    icon: 'zmdi icon',
                    iconColumns: 'zmdi-view-module',
                    iconDown: 'zmdi-expand-more',
                    iconRefresh: 'zmdi-refresh',
                    iconUp: 'zmdi-expand-less'
                },
                templates: {
                    header: "",
                },
                selection: true,
                multiSelect: true,
                rowSelect: true,
                keepSelection: true,
                statusMappings: {
                    4: "bgm-bluegray",
                    5: "bgm-pink"
                },
                formatters: {
                    "commands": function (column, row) {
                        return "<button type=\"button\" class=\"btn btn-icon command-edit waves-effect waves-circle lo-e\" title=\"Editar Oportunidad\" data-row-id=\"" + row.id + "\"><span class=\"zmdi zmdi-edit\"></span></button> " +
                                "<button type=\"button\" class=\"btn btn-icon command-cliente waves-effect waves-circle lo-c\" title=\"Ver Info. Cliente\" data-row-id=\"" + row.client_id + "\"><span class=\"zmdi zmdi-account\"></span></button>";
                    },
                    "clientes": function (column, row) {
                        if(row.subclient != "") {
                          return "<a href='../../oportunidad/editar/" + row.id + "'>" + row.cliente + " <i class=\"zmdi zmdi-city zmdi-hc-fw\" title=\"Tercera Empresa: "+row.subclient+"\"></i></a>";
                        } else if(row.integrador != "") {
                          return "<a href='../../oportunidad/editar/" + row.id + "'>" + row.cliente + " <i class=\"zmdi zmdi-camera-alt zmdi-hc-fw\" title=\"Integrador: "+row.integrador+"\"></i></a>";
                        } else {
                          return "<a href='../../oportunidad/editar/" + row.id + "'>" + row.cliente + "</a>";
                        }
                    },
                    "usuarios": function(column, row) {
                      var local_user = $("#my-name").val();
					  
					  return (row.usuario == local_user) ? row.usuario : row.usuario + " <i class=\"zmdi zmdi-account-add zmdi-hc-fw\" title=\"Sos usuario adicional\"></i>";
                    }
                }
            }).on("loaded.rs.jquery.bootgrid", function () {
                gridClient.find(".lo-e").on("click", function (e) {
                    var id = $(this).data("row-id");

                    window.location.href = "../../oportunidad/editar/" + id;
                });

                gridClient.find(".lo-c").on("click", function (e) {
                    var id = $(this).data("row-id");

                    loadInfoClient(id);

                    $('#modalWider').modal('show');
                });

                gridClient.find(".lo-d").on("click", function (e) {
                    var id = $(this).data("row-id");

                    swal({
                        title: "Está seguro de eliminar la oportunidad?",
                        text: "Se perderan todos los datos ingresados!",
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: "Si, inactivar!",
                        cancelButtonText: "No, cancelar",
                        closeOnConfirm: false
                    }, function (isConfirm) {
                        if (isConfirm) {

                            $.ajax({
                                type: "DELETE",
                                url: "../oportunidadEliminar/",
                                data: {opportunity_id: id},
                                dataType: "JSON",
                                success: function (data) {
                                    console.log(data);

                                    setTimeout(function () {
                                        window.location.reload();
                                    }, 0);

                                },
                                error: function (data) {
                                    console.log(data);

                                    notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                                }
                            });
                        }
                    });
                });
            });

            ///////////////////////////
            var changeCisn = function(el){
              $("#opportunity_integrator_user_id").val('');
              $("#opportunity_integrator_user_id_value").val('');
              $("#opportunity_subclient_id").val('');
              $("#opportunity_subclient_id_value").val('');

              if (el.is(":checked")) {
                  $("#opportunity_integrator_user_id").prop('readonly', false);
                  $("#opportunity_integrator_user_id").removeClass("bgm-gray");
                  $("#opportunity_integrator_user_id").addClass("bgm-white");

                  $("#tesn").prop('checked', false);
                  $("#opportunity_subclient_id").prop('readonly', true);
                  $("#opportunity_subclient_id").val('');
                  $("#opportunity_subclient_id").addClass("bgm-gray");
              } else {
                  $("#opportunity_integrator_user_id").prop('readonly', true);
                  $("#opportunity_integrator_user_id").val('');
                  $("#opportunity_integrator_user_id").addClass("bgm-gray");
              }
            };

            $('#cisn').change(function () {
              changeCisn($(this));
            });

            ///////////////////////////

            $('#view-client').click(function () {
                var id = $("#client_id_value").val();

                if (id != "") {
                    loadInfoClient(id);
                    $('#modalWider').modal('show');
                } else {
                    notify('No hay un cliente seleccionado', 'warning');
                }
            });

            ///////////////////////////
            var changeTesn = function(el) {
              $("#opportunity_integrator_user_id").val('');
              $("#opportunity_integrator_user_id_value").val('');
              $("#opportunity_subclient_id").val('');
              $("#opportunity_subclient_id_value").val('');

              if (el.is(":checked")) {
                  $("#opportunity_subclient_id").prop('readonly', false);
                  $("#opportunity_subclient_id").removeClass("bgm-gray");
                  $("#opportunity_subclient_id").addClass("bgm-white");

                  $("#cisn").attr("checked", false);
                  $("#opportunity_integrator_user_id").prop('readonly', true);
                  $("#opportunity_integrator_user_id").addClass("bgm-gray");
              } else {
                  $("#opportunity_subclient_id").prop('readonly', true);
                  $("#opportunity_subclient_id").addClass("bgm-gray");
              }
            };

            $('#tesn').change(function () {
              changeTesn($(this));
            });



        });

        ///////////////////////////

        function loadInfoClient(id) {

            $.ajax({
                type: "GET",
                url: "{{base_url()}}/oportunidad/jsonCliente/" + id,
                dataType: "JSON",
                success: function (data) {
                    console.log(data);

                    var cliente = data[0];
                    var milestone = data[1];
                    var vencimientos = data[2];
                    var contactos = data[3];
                    var oportunidades = data[4];

                    $("#info-nc").html(cliente[0]["client_businessname"]);
                    $("#info-cu").html(cliente[0]["client_cuit"]);
                    $("#info-or").html(cliente[0]["client_origin"]);

                    if (cliente[0]["client_invoicetype"] == "A") {
                        $("#info-tf").html("RESPONSABLE INSCRIPTO, RESP. NO INSCRIPTO, EXENTO (TIERRA DEL FUEGO)");
                    } else if (cliente[0]["client_invoicetype"] == "B") {
                        $("#info-tf").html("CONSUMIDOR FINAL, RESPONSABLE MONOTRIBUTO, IVA EXENTO");
                    } else if (cliente[0]["client_invoicetype"] == "E") {
                        $("#info-tf").html("EXPORTACIÓN");
                    }

                    $("#info-em").html(cliente[0]["client_email"]);
                    $("#info-ag").html(cliente[0]["client_agent"]);
                    $("#info-we").html(cliente[0]["client_www"]);

                    //**************

                    var miles = "";

                    for (var i in milestone) {
                        //alert(JSON.stringify(milestone[i]));

                        if (!isNaN(i)) {
                            miles += '<div class="row m-t-15">' +
                                    '<div class="col-lg-2 col-md-2 col-sm-2 col-sx-2">' +
                                    '<span class="c-green">' + milestone[i]["milestone_date"] + '</span>' +
                                    '</div>' +
                                    '<div class="col-lg-10 col-md-10 col-sm-10 col-sx-10">' +
                                    '<a href="../../oportunidad/editar/' + milestone[i]["opportunity_id"] + '">Oportunidad ' + milestone[i]["opportunity_id"] + '</a> - ' + milestone[i]["milestone_title"] + ' // ' + milestone[i]["milestone_detail"] + '' +
                                    '</div>' +
                                    '</div>';
                        }
                    }

                    $("#info-milestone").html(miles);

                    //**************

                    var oport = "";

                    for (var i in oportunidades) {
                        //alert(JSON.stringify(milestone[i])); opportunity_id, opportunity_salenumber, opportunity_type, opportunity_stage, opportunity_status, opportunity_total, opportunity_currentexpiration

                        if (!isNaN(i)) {
                            if (oportunidades[i]["opportunity_status"] == "A") {
                                oport += '<div class="row m-t-15">' +
                                        '<div class="col-lg-2 col-md-2 col-sm-2 col-sx-2">' +
                                        '<span class="c-green">' + oportunidades[i]["opportunity_createdate"] + '</span>' +
                                        '</div>' +
                                        '<div class="col-lg-10 col-md-10 col-sm-10 col-sx-10">' +
                                        '<a href="../../oportunidad/editar/' + oportunidades[i]["opportunity_id"] + '">Oportunidad #' + oportunidades[i]["opportunity_id"] + ' // Total: usd$' + oportunidades[i]["opportunity_total"] + ' // Etapa: ' + oportunidades[i]["opportunity_stage"] + '</a>' +
                                        '</div>' +
                                        '</div>';
                            } else {
                                oport += '<div class="row m-t-15">' +
                                        '<div class="col-lg-2 col-md-2 col-sm-2 col-sx-2">' +
                                        '<span class="c-red">' + oportunidades[i]["opportunity_currentexpiration"] + '</span>' +
                                        '</div>' +
                                        '<div class="col-lg-10 col-md-10 col-sm-10 col-sx-10">' +
                                        '<a href="../../venta/editar/' + oportunidades[i]["opportunity_id"] + '">Venta #' + oportunidades[i]["opportunity_salenumber"] + ' (Oportunidad #' + oportunidades[i]["opportunity_id"] + ').  Total: usd$' + oportunidades[i]["opportunity_total"] + '</a>' +
                                        '</div>' +
                                        '</div>';
                            }
                        }
                    }

                    $("#info-oportunidades").html(oport);

                    //**************

                    var venci = "";

                    for (var i in vencimientos) {
                        if (!isNaN(i)) {

                            var color = "c-green";

                            var date = vencimientos[i]["serials_contract_date"].split("-");
                            var f1 = new Date(date[0], date[1] - 1, date[2], 23, 59, 59); //31 de diciembre de 2015
                            var f2 = new Date();

                            if (f1.getTime() < f2.getTime()) {
                                color = "c-red";
                            }

                            venci += '<div class="row m-t-15">' +
                                    '<div class="col-lg-2 col-md-2 col-sm-2 col-sx-2">' +
                                    '<span class="' + color + '">' + vencimientos[i]["serials_contract_date"] + '</span>' +
                                    '</div>' +
                                    '<div class="col-lg-10 col-md-10 col-sm-10 col-sx-10">' +
                                    '<a href="../../oportunidad/editar/' + vencimientos[i]["opportunity_id"] + '">Oportunidad ' + vencimientos[i]["opportunity_id"] + '</a> - ' + vencimientos[i]["opportunity_detail_description"] + ' // ' + vencimientos[i]["serials_contract_type"] + ' #' + vencimientos[i]["serials_contract_number"] + '' +
                                    '</div>' +
                                    '</div>';
                        }
                    }

                    $("#info-vencimientos").html(venci);

                    //**************

                    var conta = "";

                    for (var i in contactos) {
                        if (!isNaN(i)) {
                            var estatus = "";
                            if (contactos[i]["contact_status"] == "0") {
                                estatus = "Inactivo";
                            } else {
                                estatus = "Activo";
                            }

                            conta += '<div class="m-15 p-15" style="border:1px solid #ccc;">' +
                                    '<div class="row">' +
                                    '<div class="col-lg-6 col-md-6 col-sm-12 col-sx-12">' +
                                    '<div class="row">	' +
                                    '	<div class="col-sm-12 m-t-15">' +
                                    '		<strong>Nombre:</strong> ' + contactos[i]["contact_name"] + '' +
                                    '	</div>	' +
                                    '	<div class="col-sm-12 m-t-15">' +
                                    '		<strong>Apellidos:</strong> ' + contactos[i]["contact_lastname"] + '	' +
                                    '	</div>' +
                                    '	<div class="col-sm-12 m-t-15">' +
                                    '		<strong>Email:</strong> ' + contactos[i]["contact_email"] + '	' +
                                    '	</div>' +
                                    '	<div class="col-sm-12 m-t-15">' +
                                    '		<strong>Cargo:</strong> ' + contactos[i]["contact_type"] + '	' +
                                    '	</div>' +
                                    '</div>' +
                                    '</div>' +
                                    '<div class="col-lg-6 col-md-6 col-sm-12 col-sx-12">' +
                                    '<div class="row">' +
                                    '<div class="col-sm-12 m-t-15">' +
                                    '	<strong>Teléfono:</strong> ' + contactos[i]["contact_phone"] + '' +
                                    '</div>	' +
                                    '<div class="col-sm-12 m-t-15">' +
                                    '	<strong>Celular:</strong> ' + contactos[i]["contact_celphone"] + '	' +
                                    '</div>	' +
                                    '<div class="col-sm-12 m-t-15">' +
                                    '	<strong>Estado:</strong> ' + estatus + '	' +
                                    '</div>' +
                                    '<div class="col-sm-12 m-t-15">' +
                                    '	<strong>Sector:</strong> ' + contactos[i]["contact_area"] + '	' +
                                    '</div>' +
                                    '</div>' +
                                    '</div>' +
                                    '</div>' +
                                    '</div> <br>';
                        }
                    }

                    if (conta == "") {
                        conta = '<div class="m-15 p-15">Cliente sin contactos registrados. <a href="../../cliente/editar/' + cliente[0]["client_id"] + '">Agregar</a></div><br>';
                    }

                    $("#info-contactos").html(conta);
                },
                error: function (data) {
                    console.log(data)
                    notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                }
            });

        }
    </script>

{% endblock %}
